package com.blazinggames.musatic
{
	import com.blazinggames.musatic.assets.Assets;
	
	import starling.animation.Tween;
	import starling.display.Image;
	import starling.display.Sprite;
	import starling.textures.Texture;

	public class Arrow extends Sprite
	{
// ***** CONSTANTS *****
		
		public static const LEFT:int = 0;
		public static const UP:int = 1;
		public static const RIGHT:int = 2;
		public static const DOWN:int = 3;
		
// ***** VARIABLES *****
		
		private var _direction:int;
		private var _tween:Tween;
		private var _image:Image;
		
// ***** CONSTRUCTOR *****
		
		public function Arrow(dir:int)
		{
			super();
			_direction = dir;
			_image = new Image(Assets.getSpriteSheet().getTexture("Arrows000"+dir));
			addChild(_image);
		}
		
// ***** METHODS - Getters and Setters *****

		public function get direction():int
		{
			return _direction;
		}

		public function set direction(value:int):void
		{
			_direction = value;
			_image.texture = Assets.getSpriteSheet().getTexture("Arrows000"+value);
		}

		public function get tween():Tween
		{
			return _tween;
		}

		public function set tween(value:Tween):void
		{
			_tween = value;
		}


	}
}