package com.blazinggames.musatic
{
	import com.blazinggames.musatic.assets.Assets;
	import com.blazinggames.musatic.assets.IScreenManager;
	
	import starling.display.Sprite;
	import starling.events.Event;
	import starling.text.TextField;
	
	public class MusaticCore extends Sprite implements IScreenManager
	{
		private var _song:Song;
		private var _titleScreen:TitleScreen;
		private var _createScreen:CreateScreen;
		private var _cheatScreen:CheatScreen;
		private var _playScreen:PlayScreen;
		private var _currentScreen:Sprite;
		private var _aboutScreen:AboutScreen;
		
		public function MusaticCore()
		{
			super();
			addEventListener(Event.ADDED_TO_STAGE, handleAddedToStage);
		}
		
		public function handleAddedToStage(e:Event):void
		{
			_song = new Song(Assets.getSoundSet());
			_song.buildTestSong();
//			_song.playSong(stage);
			_titleScreen = new TitleScreen(this);
			_createScreen = new CreateScreen(this, _song);
			_cheatScreen = new CheatScreen(this, _song);
			_playScreen = new PlayScreen(this, _song);
			_aboutScreen = new AboutScreen(this);
			_currentScreen = _titleScreen;
			addChild(_currentScreen);
		}
		
// ***** METHODS - IScreenManager implementation *****

		public function changeScreen(screenName:String):void
		{
			removeChild(_currentScreen);

			if (screenName == "Create")
				_currentScreen = _createScreen;
			else if (screenName == "Editor")
				_currentScreen = _cheatScreen;
			else if (screenName == "Play")
				_currentScreen = _playScreen;
			else if (screenName == "Title")
				_currentScreen = _titleScreen;
			else if (screenName == "About")
				_currentScreen = _aboutScreen;
				
			addChild(_currentScreen);
		}
		
	}
}