package com.blazinggames.musatic
{	
	import com.blazinggames.musatic.assets.Assets;
	
	import starling.display.DisplayObject;
	import starling.display.Image;
	import starling.display.Sprite;
	import starling.events.Event;
	import starling.events.Touch;
	import starling.events.TouchEvent;
	import starling.events.TouchPhase;
	import starling.textures.Texture;
	import starling.textures.TextureAtlas;
	
	public class NoteBox extends Sprite
	{
// ***** CONSTANTS *****
		
		public static const NOTE_TOGGLED_EVENT:String = "NOTE TOGGLED";
		
// ***** VARIABLES *****
		
		private var _noteBoxImage:Image;
		private var _noteImage:Image;
		private var _isNote:Boolean;
		private var _noteRow:int;
		private var _noteColumn:int;

		public function NoteBox(nrow:int, ncolumn:int)
		{
			super();
			_noteRow = nrow;
			_noteColumn = ncolumn;
			_isNote = false;
			var ta:TextureAtlas = Assets.getSpriteSheet();
			_noteBoxImage = new Image(ta.getTexture("Note0000"));
			addChild(_noteBoxImage);
			_noteImage = new Image(ta.getTexture("Note0001"));
			_noteImage.visible = false;
			addChild(_noteImage);
			addEventListener(TouchEvent.TOUCH, handleTouchEvent);
		}
		
		public function noteState(b:Boolean):void
		{
			_isNote = b;
			_noteBoxImage.visible = !b;
			_noteImage.visible = b;
		}
		
		public function isNote():Boolean
		{
			return _isNote;
		}
		
		private function handleTouchEvent(e:TouchEvent):void
		{
			var touch:Touch = e.getTouch(DisplayObject(e.target));
			if (touch == null) return;
			if (touch.phase == TouchPhase.ENDED)
				dispatchEvent(new Event(NOTE_TOGGLED_EVENT));
		}

		public function get row():int
		{
			return _noteRow;
		}

		public function set row(value:int):void
		{
			_noteRow = value;
		}

		public function get column():int
		{
			return _noteColumn;
		}

		public function set column(value:int):void
		{
			_noteColumn = value;
		}
	}
}