package com.blazinggames.musatic.assets
{
	import flash.display.Bitmap;
	import flash.media.Sound;
	import flash.utils.Dictionary;
	
	import starling.textures.Texture;
	import starling.textures.TextureAtlas;

	public class Assets
	{
// ***** CONSTANTS *****
		// embedded media
		[Embed(source="pluck57.mp3")]
		public static const Pluck57:Class;
		[Embed(source="pluck58.mp3")]
		public static const Pluck58:Class;
		[Embed(source="pluck59.mp3")]
		public static const Pluck59:Class;
		[Embed(source="pluck60.mp3")]
		public static const Pluck60:Class;
		[Embed(source="pluck61.mp3")]
		public static const Pluck61:Class;
		[Embed(source="pluck62.mp3")]
		public static const Pluck62:Class;
		[Embed(source="pluck63.mp3")]
		public static const Pluck63:Class;
		[Embed(source="pluck64.mp3")]
		public static const Pluck64:Class;
		[Embed(source="pluck65.mp3")]
		public static const Pluck65:Class;
		[Embed(source="pluck66.mp3")]
		public static const Pluck66:Class;
		[Embed(source="pluck67.mp3")]
		public static const Pluck67:Class;
		
		[Embed(source="spritesheet.png")]
		public static const SpriteSheetTexture:Class;		
		[Embed(source="spritesheet.xml", mimeType="application/octet-stream")]
		public static const SpriteSheetXml:Class;

// ***** VARIABLES *****
		
		private static var gameTextures:Dictionary = new Dictionary();
		private static var gameTextureAtlas:TextureAtlas;
		private static var gameSounds:Dictionary = new Dictionary();

		private static var soundSet:Array = new Array();
		
// ***** CONSTRUCTOR *****
		
		public function Assets()
		{
		}
		
		public static function getSound(name:String):Sound
		{
			if (gameSounds[name] == undefined)
			{
				var sound:Sound = new Assets[name]();
				gameSounds[name] = sound;
				trace("created sound: " + name);
			}
			return gameSounds[name];
		}
		
		public static function getTexture(name:String):Texture
		{
			if (gameTextures[name] == undefined)
			{
				var bitmap:Bitmap = new Assets[name]();
				gameTextures[name] = Texture.fromBitmap(bitmap);
				trace("created texture: " + name);
			}
			return gameTextures[name];
		}

		public static function getSoundSet():Array
		{
			if (soundSet.length < 11) {
				for (var cntr:int = 0; cntr < 11; ++cntr)
					soundSet[cntr] = getSound("Pluck" + (57 + cntr));
			}
			
			return soundSet;
		}

		public static function getSpriteSheet():TextureAtlas
		{
			if (gameTextureAtlas == null)
			{
				var texture:Texture = getTexture("SpriteSheetTexture");
				var xml:XML = XML(new SpriteSheetXml());
				gameTextureAtlas = new TextureAtlas(texture, xml);
			}
			return gameTextureAtlas;
		}
	}
}